---
title: Bluetooth
slug: Web/API/Bluetooth
tags:
  - API
  - Bluetooth
  - Experimental
  - Interface
  - Reference
  - Web Bluetooth API
---
<p>{{APIRef("Bluetooth API")}}{{securecontext_header}}{{SeeCompatTable}}</p>

<p>The <strong><code>Bluetooth</code></strong> interface of the <a href="/en-US/docs/Web/API/Web_Bluetooth_API">Web Bluetooth API</a> returns a {{jsxref("Promise")}} to a {{domxref("BluetoothDevice")}} object with the specified options.</p>

<h2 id="Interface">Interface</h2>

<pre class="syntaxbox">interface Bluetooth : EventTarget {
  Promise&lt;boolean&gt; getAvailability();
  attribute EventHandler onavailabilitychanged;
  [SameObject]
  readonly attribute BluetoothDevice? referringDevice;
  Promise&lt;sequence&lt;BluetoothDevice&gt;&gt; getDevices();
  Promise&lt;BluetoothDevice&gt; requestDevice(optional RequestDeviceOptions options = {});
};
Bluetooth includes BluetoothDeviceEventHandlers;
Bluetooth includes CharacteristicEventHandlers;
Bluetooth includes ServiceEventHandlers;
</pre>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{domxref("Bluetooth.referringDevice")}} {{readonlyinline}}</dt>
 <dd>Returns a reference to the device, if any, from which the user opened the current page. For example, an Eddystone beacon might advertise a URL, which the user agent allows the user to open. A BluetoothDevice representing the beacon would be available through <code>navigator.bluetooth.referringDevice</code>.</dd>
</dl>

<h3 id="Events">Events</h3>

<dl>
 <dt>{{domxref("Bluetooth.onavailabilitychanged")}}</dt>
 <dd>An event handler that runs when an event of type <code>availabilitychanged</code> has fired.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("Bluetooth.getAvailability","Bluetooth.getAvailability()")}}</dt>
 <dd>Returns a {{jsxref("Promise")}} that resolved to a {{jsxref("Boolean")}} indicating whether the user-agent has the ability to support Bluetooth. Some user-agents let the user configure an option that affects what is returned by this value. If this option is set, that is the value returned by this method.</dd>
 <dt>{{domxref("Bluetooth.getDevices","Bluetooth.getDevices()")}}</dt>
 <dd>Returns a {{jsxref("Promise")}} that resolved to an array of {{domxref("BluetoothDevice")}}s which the origin already obtained permission for via a call to {{domxref("Bluetooth.requestDevice","Bluetooth.requestDevice()")}}.</dd>
 <dt>{{domxref("Bluetooth.requestDevice","Bluetooth.requestDevice()")}}</dt>
 <dd>Returns a {{jsxref("Promise")}} to a {{domxref("BluetoothDevice")}} object with the specified options.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Bluetooth', '#bluetooth', 'Bluetooth')}}</td>
   <td>{{Spec2('Web Bluetooth')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Bluetooth")}}</p>
